## 常见问题FAQ

#### 问：这款脚本会不会泄露我的秘钥、cookie、客户端连接密码？

答：绝对不会！！代码全开源，能经受审查！所有私密配置只在本地存储使用，绝不会发送给任何第三方。

#### 问：只使用IYUU自动辅种，需要配置各站的cookie吗？

答：只需配置全局客户端和各网站的passkey密钥（没有配置passkey的站点，在辅种时候会跳过）。2019年12月28日补充：辅种hdcity、hdchina需要配置cookie。

#### 问：IYUU自动辅种工具，向服务器发送了什么实现自动辅种呢？

答：1.文件`phpspider\app\torrent\cache\hashString.txt`是脚本发送给服务器的数据，是按下载器分组的种子info_hash；2.文件`phpspider\app\torrent\cache\reseed.txt`是服务器返回的可辅种数据。

#### 问：本次添加成功的辅种任务，下次辅种时还会重复添加吗？

答：添加成功的辅种任务，会在本地生成缓存记录，避免重复添加辅种任务，路径在：`phpspider\app\torrent\cachehash`。

#### 问：为什么有些站点自动跳过？

答：因为站点在下载种子时有流控或者人机验证，会导致辅种失败；但脚本会在`phpspider\app\torrent\cache`目录下生成以站点命名的手动辅种文本。

#### 问：我拥有辅种时自动跳过站点的特殊权限，如何设置为可以辅种呢？

答：在站点的独立配置区域，添加一行代码`'is_vip'   => 1,`即可。例如Ourbits：

```php
// ourbits
'ourbits'      => array(
	// 如果需要用下载免费种脚本，须配置（只是自动辅种，可以不配置此项）
	'cookie'        => '',
	// 如果需要自动辅种，必须配置
	'passkey'       => '',
	'id' 			=> 46880,	// 用户ID
	'is_vip'		=> 1,		// 是否具有VIP或特殊权限？0 普通，1 VIP
),
```



#### 问：如何升级到最新版本？

答：从github或码云仓库，下载最新的源码，覆盖到本地即可。

#### 问：为啥我编辑配置后，运行的时候显示乱码？

答：保存的编码格式不对，正确的格式为UTF8(无BOM)；推荐编辑器：`VS code`、`EditPlu`s、`SublimeText`、`Notepad++`。

#### 问：为什么用IYUU自动辅种，有些种子无法校验通过？

答：首先，这个属于正常现象。 只要IYUU自动辅种匹配过来，然后校验通不过的，分为以下几种情况： 

1、被改了文件名，重新做种 

2、被改了顶层目录名，重新做种 

3、把单文件放进了目录里面，重新做种 

4、更改了部分文件，例如nfo文件，重新做种

一般情况下，通过分析种子结构，创建软连接，90%以上都可以辅种成功。
也可以不管他或删除校验失败的任务(不要删除数据)。 

#### 问：如何创建软连接、硬链接手动辅种？

答：Windows命令： `mklink`， Linux命令： `ln -s`， 更详细的用法请百度。

#### 问：IYUU自动辅种，添加计划任务后多久运行一次比较合适？

答：为减轻服务器压力，推荐间隔3小时以上（太频繁的调用接口，可能被封禁）。

#### 问：猫站的Tracker为啥是http，而不是https？

答：请退出登录，在登录时勾选下面两个SSL的选项，登录后复制cookie，重新配置。

#### 问：如何反馈问题？

答：1、点击链接加入群聊【IYUU自动辅种交流】：[https://jq.qq.com/?_wv=1027&k=5JOfOlM][1]

2、QQ群：859882209

3、issues： https://gitee.com/ledc/IYUUAutoReseed/issues 

